/*
 * Fl_Dock_Group.H z_hossain 22-01-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA.
 *
 */


#ifndef FL_DOCK_GROUP_H
#define FL_DOCK_GROUP_H

#include <FL/Fl_Window.H>

#define MAX_TOOLBAR 10

struct Fl_Center_Rect {
	int x1, y1, x2, y2;
	Fl_Center_Rect() {
		x1 = y1 = x2 = y2 = 0;
	}

	void set(int x1, int y1, int x2, int y2) {
		Fl_Center_Rect::x1 = x1;
		Fl_Center_Rect::x2 = x2;
		Fl_Center_Rect::y1 = y1;
		Fl_Center_Rect::y2 = y2;
	}
};

class Fl_Dock_Group : public Fl_Group {
	Fl_Widget *widget_;
	Fl_Window *toolbar_[MAX_TOOLBAR];
	Fl_Center_Rect rect_;
	void resize_delta(Fl_Window *, int, int, int, int);

public:
	Fl_Dock_Group( int, int, int, int, const char* = 0 );
	~Fl_Dock_Group();

	int dock(Fl_Window *, uchar);
	int undock(Fl_Window *);
	Fl_Widget *widget() const { return widget_; }
	void widget(Fl_Widget *w) { widget_ = w; }

protected:
	int handle(int arg );
	void draw();
};

#endif
