/*
 * Fl_Dock_Group.cxx z_hossain 22-01-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA.
 *
 */

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/fl_draw.H>
#include <FL/Fl_Button.H>

#include <stdio.h>

#include "Fl_Dock_Group.H"

Fl_Dock_Group::Fl_Dock_Group(int X, int Y, int W, int H,const char *l)
: Fl_Group(X, Y, W, H, l) {
	box(FL_FLAT_BOX);
	rect_.set(x(), y(), x() + w(), y() + h());
}


Fl_Dock_Group::~Fl_Dock_Group() {}


int Fl_Dock_Group::handle( int arg ) {
	return Fl_Group::handle( arg );
}

void Fl_Dock_Group::draw() {
	Fl_Group::draw();
}

int Fl_Dock_Group::dock(Fl_Window *win, uchar align) {
	switch(align) {
		case FL_ALIGN_LEFT:
			win->position(x(), y());
			widget_->resize(x(), y(), w(), h());
			resize_delta(win, win->w(), 0, -win->w(), 0);
			break;
		case FL_ALIGN_RIGHT:
			win->position(x() + w() - win->w(), y());
			widget_->resize(x(), y(), w(), h());
			resize_delta(win, 0, 0, -win->w(), 0);
			break;
		case FL_ALIGN_TOP:
			win->position(x(), y());
			widget_->resize(x(), y(), w(), h());
			resize_delta(win, 0, win->h(), 0, -win->h());
			break;
		case FL_ALIGN_BOTTOM:
			win->position(x(), y() + h() - win->h());
			widget_->resize(x(), y(), w(), h());
			resize_delta(win, 0, 0, 0, -win->h());
			break;
	}
	redraw();
	return 1;
}

int Fl_Dock_Group::undock(Fl_Window *win) {
	widget_->resize(x(), y(), w(), h());
	return 1;
}

void Fl_Dock_Group::resize_delta(Fl_Window *win, int X, int Y, int W, int H) {
	widget_->resize(widget_->x() + X, widget_->y() + Y, widget_->w() + W, widget_->h() + H);
}
