/*
 * Fl_Tool_Button.cxx z_hossain 22-01-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA.
 *
 */

#include "Fl_Tool_Button.H"

Fl_Tool_Button::Fl_Tool_Button(const char *l) : Fl_Button(0, 0, 50, 50, l) {
	box(FL_FLAT_BOX);
	down_box(FL_DOWN_BOX);
}

void Fl_Tool_Button::draw() {
	if (type() == FL_HIDDEN_BUTTON) return;
	Fl_Color col = value() ? selection_color() : color();
	draw_box(value() ? (down_box()?down_box():fl_down(box())) : box(), col);
	draw_label();
}

int Fl_Tool_Button::handle(int arg) {
	switch(arg) {
		case FL_ENTER:
			box(FL_THIN_UP_BOX);
			//draw_box(FL_THIN_UP_BOX, color());
			//draw_label();
			redraw();
			return 1;
		case FL_LEAVE:
			box(FL_FLAT_BOX);
			//draw_box(FL_FLAT_BOX, color());
			//draw_label();
			redraw();
			return 1;
	}
	return Fl_Button::handle(arg);
}

Fl_Tool_Button::~Fl_Tool_Button() {
}
