/*
 * Fl_Toolbar.H z_hossain 22-01-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA.
 *
 */

#ifndef Fl_Toolbar_H
#define Fl_Toolbar_H

#include <FL/Fl_Window.H>
#include <FL/Fl_Menu_Button.H>

#include "Fl_Dock_Group.H"
#include "Fl_Tool_Button.H"

class Fl_Drag_Button : public Fl_Menu_Button {
public:
	Fl_Drag_Button(Fl_Widget *w);

	void draw();
	int handle(int);
};


class Fl_Toolbar : public Fl_Window {
	Fl_Drag_Button *drag_;
	Fl_Dock_Group *dock_group_;
	uchar orientation_;

	uchar state_;
	uchar dockable_;

public:
	enum {
		FL_STATE_DOCKED = 0,
		FL_STATE_UNDOCKED,
	};
	enum{	
		FL_ORIENTATION_VERTICAL = 0,
		FL_ORIENTATION_HORIZONTAL
	};

	Fl_Toolbar(int, int, int, int, const char* = 0);
	~Fl_Toolbar();


	void dock_group(Fl_Dock_Group *g) { dock_group_ = g; }
	Fl_Dock_Group *dock_group() const { return dock_group_; }
	Fl_Drag_Button *drag_button() { return drag_; }
	void draw();
	int handle(int event);

	void dockable(uchar a) { dockable_ = a; }
	uchar dockable() const { return dockable_; }

	uchar state() const { return state_; }

	void cb_menu();
	Fl_Tool_Button *add_button(const char *);
};

#endif
